var flood = require('../Models/Flood');
var auth = require('everyauth');

FloodController = function(floodRepository, photosRepository, locationService)
{
	this.floodRepository = floodRepository;
	this.locationService = locationService;
	this.photosRepository = photosRepository;
}

FloodController.prototype = {
	Index: function(req, resp){
		this.floodRepository.GetAllFloods(function(error, floodEntities){
			var floods = [];

			for (var i = 0; i < floodEntities.length; i++) {
				var floodEntity = floodEntities[i];
				
				var flood = {
					DateCreated: floodEntity.PartitionKey,
					Title: floodEntity.RowKey,
					Description: floodEntity.Description,
					Address: floodEntity.Address,
					GeoLocation: floodEntity.GeoLocation,
					Photos: floodEntity.Photos,
					Popularity: floodEntity.Popularity
				};


				floods.push(flood);
			};

			resp.render('Flood/Index', {floods: floods});
		});
	},

	CreateGet: function(req, resp){
		resp.render('Flood/Create');
	},

	CreatePost: function(req, resp){
		var data = req.body;
		flood.Title = data.Title
		flood.Description = data.Description;
		flood.UserID = req.user;
		flood.Address = data.Rua + ", " + data.Bairro + ", " + data.Cidade + ", " + data.Estado + ", " + data.CEP;
		flood.GeoLocation = "0, 0";
		flood.Photos = " ";
		flood.Popularity = 0;

		var floodRepository = this.floodRepository;

		this.locationService.GeocodeAddress(flood.Address, function(geocodeResult){
			if(!geocodeResult.error)
			{
				flood.GeoLocation = geocodeResult.lat + ',' + geocodeResult.lng;
			}

			console.log(floodRepository);

			floodRepository.InsertFlood(flood, function(error, floodEntity){
				if(error === null){
					resp.writeHead('302', {'Location': '/Flood/Details/' + floodEntity.PartitionKey + '/' + floodEntity.RowKey});
					resp.end();
				}
				else
				{
					console.log('an error occurred in create post');
					console.log(error);
				}
			});
		});
	},

	Details: function(req, resp){
		var date = req.params.date;
		var title = req.params.title;

		this.floodRepository.QueryForFlood(date, title, function(error, floodEntity){
			if(error === null){
				flood.DateCreated = floodEntity.PartitionKey;
				flood.Title = floodEntity.RowKey;
				flood.Description = floodEntity.Description;
				flood.UserID = floodEntity.UserID;
				flood.Address = floodEntity.Address;
				flood.GeoLocation = floodEntity.GeoLocation;
				flood.Photos = floodEntity.Photos;
				flood.Popularity = floodEntity.Popularity;

				resp.render('Flood/Details', {flood: flood, url: 'http://local.host:8080/' + req.url});
			}
			else
			{
				console.log('an error occurred in details');
				console.log(error);
			}
		});
	},

	SearchPost: function(req, resp){
		resp.writeHead('302', {Location: 'Flood/Search?query=' + req.body.query})
		resp.end();
	},

	SearchGet: function(req, resp){
		var query = req.query.query;

		query = query.replace(/\+/g, ' ');

		this.floodRepository.SearchForFloods(query, function(error, floodEntities){
			var floods = [];

			for (var i = 0; i < floodEntities.length; i++) {
				var floodEntity = floodEntities[i];
				
				var flood = {
					DateCreated: floodEntity.PartitionKey,
					Title: floodEntity.RowKey,
					Description: floodEntity.Description,
					UserID: floodEntity.UserID,
					Address: floodEntity.Address,
					GeoLocation: floodEntity.GeoLocation,
					Photos: floodEntity.Photos,
					Popularity: floodEntity.Popularity
				};


				floods.push(flood);
			};

			resp.render('Flood/Search', {floods: floods});
		});
	},

	UploadPhoto: function(req, resp, filePath){
		var files = req.files;
		var fileData;
		console.log(files.fileUpload._writeStream);
		var dateCreated = req.body.DateCreated;
		var title = req.body.Title;
		var self = this;
		
		var blobUri = this.
						photosRepository
						.UploadPhoto(filePath, 
									'photos', 
									files.fileUpload.name, 
									'Photo1',
									files.fileUpload.type,  
									function(error, blob, response){
										if(!error){
											self.floodRepository.QueryForFlood(dateCreated, title, function(errorQuery, floodEntity){
												floodEntity.Photos += blobUri + ';';
												self.floodRepository.UpdateFlood(floodEntity, function(errorUpdate, floodEntity){
													
													console.log(errorUpdate);

													resp.writeHead('302', {'Location': '/Flood/Details/' + floodEntity.PartitionKey + '/' + floodEntity.RowKey});
													resp.end();
												});
											});
										}
									});
	}
}