require('./Controllers/HomeController');
require('./Controllers/FloodController');
require('./Storage/FloodCloudRepository');
require('./Services/GoogleLocationService');
require('./Storage/PhotosRepository');


module.exports = function Routes(server, httpClient){

	var homeController = new HomeController();

	var floodRepository = new FloodCloudRepository();
	floodRepository.Setup();

	var photosRepository = new PhotosRepository();
	photosRepository.Setup(function(error, containerExists, response){ if(containerExists === true) console.log('container existis');});

	var locationService = new GoogleLocationService(httpClient);

	var floodController = new FloodController(floodRepository, photosRepository, locationService);

	server.get('/', function(req, resp){
		homeController.Index(req, resp);
	});

	server.get('/Home', function(req, resp){
		homeController.Index(req, resp);
	});

	server.get('/Flood/Index', function(req, resp){
		floodController.Index(req, resp);
	})

	server.get('/Flood/Create', function(req, resp){
		console.log(req.user);
		if(!req.user)
			resp.render('Shared/Error', {message: 'First you need to login to do this'});
		else
			floodController.CreateGet(req, resp);
			
	});

	server.post('/Flood/Create', function(req, resp){
		if(!req.user){
			resp.writeHead('401');//unauthorized
			resp.end();
		}
		else
			floodController.CreatePost(req, resp);
	});

	server.get('/Flood/Details/:date/:title', function(req, resp){
		floodController.Details(req, resp);
	});

	server.post('/Flood/Search', function(req, resp){
		floodController.SearchPost(req, resp);
	});

	server.get('/Flood/Search', function(req, resp){
		floodController.SearchGet(req, resp);
	});

	server.post('/photo', function(req, resp){
		var filepath = __dirname + '/' + req.files.fileUpload.path;
		console.log(filepath);
		floodController.UploadPhoto(req, resp, filepath);
	})
}