GoogleLocationService = function(httpClient){
	this.httpClient = httpClient;
	this.path = '/maps/api/geocode/json?address=';
	this.googleServiceDomain = 'maps.googleapis.com';

}

GoogleLocationService.prototype = {
	GeocodeAddress: function(address, onGeocodeCompleted){
		address = address.replace(/ /g, '+');

		this.httpClient.host = this.googleServiceDomain;

		var path = this.path + address + '&sensor=false';

		var request = this.httpClient.request('GET', path, {'host': this.googleServiceDomain});
		request.end();

		var jsonResponse = '';
		request.on('response', function(response){
			if(response.statusCode === 200){
				response.on('data', function(data){
					jsonResponse += data;
				});
				response.on('end', function(){
					var jsonResult = JSON.parse(jsonResponse);

					if(jsonResult.status === 'OK'){
						var location = jsonResult.results[0].geometry.location;

						console.log(location);

						onGeocodeCompleted(location);
					}
					else
						onGeocodeCompleted({error: 'Geocoding failed for address ' + address});
				})
			}
			else{
				console.log(response.statusCode);
				onGeocodeCompleted({error: 'An error ocurred when trying to geolocate address ' + address});
			}
				
		})
	}
}