var azure = require('azure');

FloodCloudRepository = function()
{
	this.azureStorageKey = "+FVxKre69tDFvxQP7vqY5IX8WtkSPeAuuUwtpQ4NR9V0l1LLMv4BCHtkPiPgiUCNe4i8i053fdDRY+qTSOuqyw==";
	this.storageAccount = "sosenchente";
	this.floodTableName = "floods";
}

FloodCloudRepository.prototype = {

	CreateTableServiceClient: function(){
		var tableServiceClient = azure.createTableService(this.storageAccount, 
														  this.azureStorageKey, 
														  azure.ServiceClient.CLOUD_TABLE_HOST);

		return tableServiceClient;
	},

	GetCurrentDate: function(){
		var currentTime = new Date()
		var month = currentTime.getMonth() + 1;
		var day = currentTime.getDate();
		var year = currentTime.getFullYear();
		var milliseconds = currentTime.getTime()
		var formattedDate = day + "-" + month + "-" + year;

		return formattedDate;
	},

	Setup: function(){
		var tableServiceClient = this.CreateTableServiceClient();

		tableServiceClient.createTableIfNotExists(this.floodTableName, function(res, created){
			if(!created){
				console.log("Table not created");
			}
		});
	},

	GetAllFloods: function(onQueryCompleted){
		var tableServiceClient = this.CreateTableServiceClient();

		var query = azure.TableQuery.select().from(this.floodTableName);

		tableServiceClient.queryEntities(query, onQueryCompleted);
	},

	InsertFlood: function(flood, onInsertCompleted){
		var formattedDate = this.GetCurrentDate();

		var floodTableEntity = {
			PartitionKey: formattedDate,
			RowKey: flood.Title,
			Description: flood.Description,
			UserID: flood.UserID,
			Address: flood.Address,
			GeoLocation: flood.GeoLocation,
			Photos: flood.Photos,
			Popularity: flood.Popularity
		};

		var tableServiceClient = this.CreateTableServiceClient();

		console.log(floodTableEntity);
		// console.log(tableServiceClient);
		tableServiceClient.insertEntity(this.floodTableName, floodTableEntity, onInsertCompleted);
	},

	UpdateFlood: function(flood, onUpdateCompleted){
		var formattedDate = this.GetCurrentDate();

		var floodTableEntity = {
			PartitionKey: flood.DateCreated ? flood.DateCreated : flood.PartitionKey,
			RowKey: flood.Title ? flood.Title : flood.RowKey,
			Description: flood.Description,
			UserID: flood.UserID,
			Address: flood.Address,
			GeoLocation: flood.GeoLocation,
			Photos: flood.Photos,
			Popularity: flood.Popularity
		};

		var tableServiceClient = this.CreateTableServiceClient();

		console.log(floodTableEntity);
		// console.log(tableServiceClient);
		tableServiceClient.updateEntity(this.floodTableName, floodTableEntity, onUpdateCompleted);
	},

	SearchForFloods: function(filter, onQueryCompleted){
		var tableServiceClient = this.CreateTableServiceClient();

		var query = azure.TableQuery.select().from(this.floodTableName).where('RowKey eq ?', filter);

		tableServiceClient.queryEntities(query, onQueryCompleted);
	},

	QueryForFlood: function(date, title, onQueryCompleted){
		var PartitionKey = date;
		var RowKey = title;

		var tableServiceClient = this.CreateTableServiceClient();
		tableServiceClient.queryEntity(this.floodTableName, PartitionKey, RowKey, onQueryCompleted);
	}
}